#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <errno.h>
#include <fcntl.h>
#include <regex.h>

#include "defs.h"

inline void initdata(void) { 
    memset(&kanaler, 0, sizeof(kanaler)); 
    memset(&watch, 0, sizeof(watch));
    memset(&extalarm1, 0, sizeof(extalarm1));
    memset(&extalarm2, 0, sizeof(extalarm2));

}

int reload(int bootup) { // call ONLY with bootup=1 from main()
    
    FILE *f;
    char buf[512], *p;
    int i, j, k, currwatch=0;
    static int fd;
    
    colorcfg=0;
    bordercfg=0;
    clockcfg=0;
    topspacecfg=0;
    regexwatch=0;
    
    alarm1=0;       
    alarm2=0;

    snprintf(buf, sizeof(buf), "%s/.tvconfig", getenv("HOME")); // still possible when forked?
    //snprintf(buf, sizeof(buf), "./.tvconfig");
    
    if ((f = fopen(buf,"r")) == NULL) { 
        printf("Can't open %s/.tvconfig\n",getenv("HOME"));
        exit(-1); // cant open config! nothing to do
    }

    forking=0; // reset
    initdata(); //reset lists

    while (fgets(buf, sizeof(buf), f) != NULL) {
        strip_trailing_crnl(buf);

        if (strcasecmp(buf, "COLOR") == 0) colorcfg=1;
        else if (strcasecmp(buf, "TOPSPACE") == 0) topspacecfg=1;
        else if (strcasecmp(buf, "BORDER") == 0) bordercfg=1;
        else if (strcasecmp(buf, "CLOCK") == 0) clockcfg=1;
        else if (strcasecmp(buf, "REGEX") == 0) regexwatch=1;
        
        if ((p = strchr(buf, ' ')) != NULL) { 
            *p++ = '\0';
            if (strcasecmp(buf, "CHANNEL") == 0) filldata(p);
            else if (strcasecmp(buf, "FORK") == 0) { 
                forking = 1; 
                strncpy(tty, p, sizeof(tty)-1);
                tty[sizeof(tty)-1]='\0';

                if(bootup == 1 && fork() != 0) exit(0);
                if(bootup == 1) { close(0); close(1); close(2); }
                else { close(fd); } // its probably dangerous to close 1,2 cept at boot because of f
                if ((fd = open(p, O_RDWR)) == -1) exit(-1); // not much to do..
            }  
            else if (strcasecmp(buf, "WATCH") == 0) {
                if (currwatch == MAXWATCH) break;
                strncpy(watch[currwatch], p, 32);
                watch[currwatch++][31] = '\0';
            }
            else if (strcasecmp(buf, "ALARM1") == 0) { 
                alarm1 = atoi(p);
            }   
            else if (strcasecmp(buf, "ALARM2") == 0) { 
                alarm2 = atoi(p);
            }   
            else if (strcasecmp(buf, "EXTALARM1") == 0) { 
                strncpy(extalarm1, p, sizeof(extalarm1));
            }   
            else if (strcasecmp(buf, "EXTALARM2") == 0) { 
                strncpy(extalarm2, p, sizeof(extalarm2));
            }   
        }
    }

    if (bordercfg == 1)
        topspacecfg = 1;
    
    if(findfreekanal() == 0) { // NO CHANNELS?!?
        exit(0); 
    }  
    fclose(f);

    if (regexwatch == 1) {
        /* match with regex */
        regex_t rexp[currwatch+1];
        for (k = 0; k < currwatch; k++) 
            regcomp(&rexp[k], watch[k], REG_EXTENDED | REG_ICASE);
        
        for(k = 0; k < currwatch; k++)
            for(i = 0; (i < 16 && kanaler[i].used == 1); i++)
                for(j = 0; (j < MAXCHAN && kanaler[i].program[j][0] != ' '); j++)
                    if ((regexec(&rexp[k], kanaler[i].program[j], 0, NULL, 0)) == 0)  
                        kanaler[i].watch[j] = 1;
                    
                    
    }
    else {
        /* match with strncasecmp() */  
        for(k = 0; k < currwatch; k++)  
            for(i = 0; (i < 16 && kanaler[i].used == 1); i++)
                for(j = 0; (j < MAXCHAN && kanaler[i].program[j][0] != ' '); j++)
                    if (strncasecmp(kanaler[i].program[j], watch[k], strlen(watch[k])) == 0)
                        kanaler[i].watch[j] = 1;
    }                            
    
    return 0;
}

int filldata(char *file) {

    struct sockaddr_in	sin;
    int    sfd;
    int    len, freekanal, currprogram = 0, i = 0;
    char   *buf;
    char   *p, *q, *t, *r;
    char   recvbuf[4096];
    char   cpmongo = 0;

    if (file == NULL)
        return(-1);

    if ((sfd = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1 ) return(-1);
    sin.sin_family = PF_INET;
    sin.sin_port = htons(80);
    sin.sin_addr.s_addr = inet_addr("212.105.63.152"); // tvprogram.nu

    memset(&sin.sin_zero,0,sizeof(sin.sin_zero));

    if (connect(sfd, (struct sockaddr *)&sin, sizeof(sin)) == -1 ) { close(sfd); return(-1); }

    sprintf(recvbuf, "\nGET /cgi-tvprogram/pp1.cgi?%s HTTP/1.1\nHOST: blaha.com\n\nBYE\n\n", file); //safe
    if (send(sfd,recvbuf,strlen(recvbuf),0) == -1) { printf("error sending for %s\n", file); perror(NULL);close(sfd); return(-1); }
    if ((buf = p = (char *) malloc(100000)) == NULL) { close(sfd); return(-1); }
    memset(buf, 0, 100000);

    while ((len = recv(sfd,recvbuf,sizeof(recvbuf),0)) > 0) {
        if (p-buf+len > 100000) { printf("error reading, too much\n");close(sfd); free(buf); return(-1); } // heh. someone rooted tvprogram.nu just for me? :P 
        memcpy(p, recvbuf, len);  
        p += len;
    }

    p = buf;
    strip_cpcr(buf);
    if ((freekanal = findfreekanal()) == -1) { free(buf); close(sfd); return(-1); }
    kanaler[freekanal].used = 1;

    while((p = strstr(p, "<b>")) != NULL ) {
        p += 3;
        q = strstr(p, "</b>");
        *q = '\0';
        strip_trailing_crnl(p);
        //printf("%s\n",p);
        
        if (*p == '\0') { p = q+3; continue; }
        if (currprogram == MAXCHAN) break; // FALL BACK FALL BACK FALL BACK

        if (i == 0) { 
            if (isdigit(*p)) {
                cpmongo = 1;
                if ((r = strchr(file,'-'))) {
                    *r = '\0';
                    strcpy(kanaler[freekanal].name, file);
                    kanaler[freekanal].name[31] = '\0';
                }
                else {
                    strcpy(kanaler[freekanal].name, "Unknown");
                    kanaler[freekanal].name[31] = '\0';
                }
            }
            else {
                strcpy(kanaler[freekanal].name, p);
                kanaler[freekanal].name[31] = '\0'; // NULLTERM!
            }
        }
        else if (i%2 == 0) { // programname
            memcpy(kanaler[freekanal].program[currprogram], p, (strlen(p) > 31) ? 31 : strlen(p)-1);
            kanaler[freekanal].program[currprogram][31] = '\0';
            currprogram++;
        }
        else { // time
            if ((t = strchr(p, ':')) == NULL && (t = strchr(p, '.')) == NULL) { // great. why not use ! too.
                free(buf);
                close(sfd);
                kanaler[freekanal].used = 0;
                return(-1);
            }
            *t++ = '\0'; 
            kanaler[freekanal].starttid[currprogram] = atoi(t) + 60*atoi(p);
        }    

        if (cpmongo == 1) {
            p = buf;
            cpmongo = 0;
            *q = '<';
        }
        else 
            p = q+3;
        
        i++;
    }  

    free(buf);
    close(sfd);
    return(1);
}

void strip_trailing_crnl(char *p) // p is NULL terminated
{
    char *q;
    
    if (*(p+strlen(p)-1) == '\n' || *(p+strlen(p)-1) == '\r') {
        *(p+strlen(p)-1) = '\0';
        strip_trailing_crnl(p);
    }     
   
    /* fix ' och ` */
    
    while ((q = strchr(p,0x92)) != NULL)
        *q = '\'';

    while ((q = strchr(p,0x91)) != NULL)
        *q = '`';

}

void strip_cpcr(char *buf) { // buf is NULL terminated
    char *p, *q;

    if ((p = strchr(buf, '\r')) == NULL || (q = strchr(p+1, '\r')) == NULL) return;  
    if (*(q+1) == '\n') q++;

    strcpy(p,q+1); // unless strcpy is coded by some retard this will work regardless of the overlap
    strip_cpcr(p);
}

int findfreekanal(void) {
    int i;
    for (i=0;i<16;i++)
        if (kanaler[i].used == 0) return i;
    return(-1);
}

    
